_.namespace('marketstar');

/**
 * Constructor
 *
 * @class CertificationDetail
 * @constructor
 * @extends _.ViewController
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.CertificationDetail = function(el, data) {
    $.extend(marketstar.CertificationDetail.prototype, Constants);
    $.extend(marketstar.CertificationDetail.prototype, UtilMixins);
    $.extend(marketstar.CertificationDetail.prototype, AjaxMixins);
    $.extend(marketstar.CertificationDetail.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.CertificationDetail.prototype = Object.create(marketstar.ViewController.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.CertificationDetail.prototype.init = function() {
    this.localStorage = new marketstar.LocalStorageObserverProxy();

    this.parseQueryParametersIntoModel();
    if( !this.model.getPath('queryParams.certificationId') ) {
        this.goBack();
    }

    this.certificationId = this.model.getPath('queryParams.certificationId');
    this.localStorage.registerObserver('certifications', this, this.updateModelFromLocalStorage);
    this.$('a.back-arrow').on('click', function(e){
        location.href = "certificationsMain.html";
    });

    this.model.set(
            'templatePaths'
            ,{
                navigation: '_navigation.html'
                , userBar: '_userBar.html'
                , socialLinks: '_socialLinks.html'
                , appVersion: '_appVersion.html'
                , certificationDetailView: '_certificationDetailView.html'
            }
    );

    this.loadIntoModelFromLocalStorage(
            this.userDataKey
            ,$.proxy(this.loadTemplates, this)
            ,$.proxy(this.redirectToIndex, this)
    );
};


/**
 * onTemplatesReady event handler
 *
 * @method onTemplatesReady
 */
marketstar.CertificationDetail.prototype.onTemplatesReady = function() {
    this.loadIntoModelFromLocalStorage(
            'certifications'
            ,$.proxy(this.renderCertificationDetail, this)
            //,this.goBack   TODO What if there is an error? CMS
    );
}


/**
 * Adds the certification information to the model.
 *
 * @method renderCertificationDetail
 * @param requestProps {Object}
 * @param xhr          {Object}
 */
marketstar.CertificationDetail.prototype.renderCertificationDetail = function(requestProps, xhr) {
    var certification = this.model.getArrayObject('Id', this.certificationId, 'certifications');
    this.model.setPath('certification', certification);

    var data = $.extend(
            certification
            ,{
                renderTarget: this.$('.certification-detail-container')
            }
    );

    var template = $(_.template(this.model.getPath('templates.certificationDetailView'), certification));

    var child = new marketstar.CertificationDetailView(
        template
        ,data
    );
    this.addChild(child);

};
