_.namespace('marketstar');

/**
 * Constructor
 *
 * @class CertificationsMain
 * @constructor
 * @extends _.ViewController
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.CertificationsMain = function (el, data) {
    $.extend(marketstar.CertificationsMain.prototype, Constants);
    $.extend(marketstar.CertificationsMain.prototype, UtilMixins);
    $.extend(marketstar.CertificationsMain.prototype, AjaxMixins);
    $.extend(marketstar.CertificationsMain.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.CertificationsMain.prototype = Object.create(marketstar.ViewController.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.CertificationsMain.prototype.init = function () {
    this.localStorage = new marketstar.LocalStorageObserverProxy();

    this.model.set(
            'templatePaths'
            , {
                navigation: '_navigation.html'
                , userBar: '_userBar.html'
                , socialLinks: '_socialLinks.html'
                , appVersion: '_appVersion.html'
            }
    );

    this.loadIntoModelFromLocalStorage(
            this.userDataKey
            , $.proxy(this.loadTemplates, this)
            , $.proxy(this.redirectToIndex, this)
    );
};

/**
 * Render the page
 *
 * @method templatesReady
 */
marketstar.CertificationsMain.prototype.onTemplatesReady = function () {

};