_.namespace('marketstar');

/**
 * Constructor
 *
 * @class ContentDetailFile
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 * @uses ContentMixins
 */
marketstar.ContentDetailFile = function(el, data) {
    $.extend(marketstar.ContentDetailFile.prototype, Constants);
    $.extend(marketstar.ContentDetailFile.prototype, AjaxMixins);
    $.extend(marketstar.ContentDetailFile.prototype, UtilMixins);
    $.extend(marketstar.ContentDetailFile.prototype, PageMixins);
    $.extend(marketstar.ContentDetailFile.prototype, ContentMixins);
    this.construct(el, data);

};

marketstar.ContentDetailFile.prototype = Object.create(marketstar.DataView.prototype);

marketstar.ContentDetailFile.prototype.init = function() {
    this.localStorage = new marketstar.LocalStorageObserverProxy();
    this.loadIntoModelFromLocalStorage(this.userDataKey);
};

marketstar.ContentDetailFile.prototype.templatesReady = function() {

};

marketstar.ContentDetailFile.prototype.postRender = function() {
    this.registerContentDetailClicks();
    this.updateImageFromAjax('.feed-author-avatar', this.model.data.author.resources.avatar.ref);
};