_.namespace('marketstar');

/**
 * Constructor
 *
 * @class ContentDetailPoll
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 * @uses ContentMixins
 */
marketstar.ContentDetailPoll = function(el, data) {
    $.extend(marketstar.ContentDetailPoll.prototype, Constants);
    $.extend(marketstar.ContentDetailPoll.prototype, AjaxMixins);
    $.extend(marketstar.ContentDetailPoll.prototype, UtilMixins);
    $.extend(marketstar.ContentDetailPoll.prototype, PageMixins);
    $.extend(marketstar.ContentDetailPoll.prototype, ContentMixins);
    this.construct(el, data);

};

marketstar.ContentDetailPoll.prototype = Object.create(marketstar.DataView.prototype);

marketstar.ContentDetailPoll.prototype.init = function() {
    this.localStorage = new marketstar.LocalStorageObserverProxy();
    this.loadIntoModelFromLocalStorage(this.userDataKey);
};

marketstar.ContentDetailPoll.prototype.templatesReady = function() {

};

marketstar.ContentDetailPoll.prototype.postRender = function() {
    this.registerContentDetailClicks();
    this.updateImageFromAjax('.feed-author-avatar', this.model.data.author.resources.avatar.ref);
    this.getPollOptions();
};

marketstar.ContentDetailPoll.prototype.getPollOptions = function() {
    var url = this.model.getPath('resources.votes.ref');

    this.basicAuthAjaxCall({
        url:        url
        ,type:      "GET"
        ,basicAuth: this.model.get(this.userDataKey).authHash
        ,modelName: 'pollVotes'
        ,async: false
        ,success:   $.proxy(this.renderPollOptions, this)
        ,fail:      ''
    });
}

marketstar.ContentDetailPoll.prototype.renderPollOptions = function(){
    var votes = this.model.getPath('pollVotes').list;
    var i=0;
    while(i < votes.length)
    {
        var vote = votes[i];
        this.$('.poll-options').append('<li>'+(this.model.data.voteCount ? (vote.count/this.model.data.voteCount)*100 : 0)+'% ('+vote.count+'/'+this.model.data.voteCount +') ' +vote.option +'</li>');
        i++;
    }

}