_.namespace('marketstar');

/**
 * Constructor
 * 
 * @class DataView
 * @constructor
 * @extends sudo.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses PageMixins
 */
marketstar.DataView = function() {}

// subclass sudo's DataView
marketstar.DataView.prototype = Object.create(sudo.DataView.prototype);

/**
 * Make this class essentially abstract.
 * 
 * @method postRender
 */
marketstar.DataView.prototype.postRender = function() {
    throw "Unimplemented method error";
}

/**
 * Override the default addedToParent method to wire in a callback.
 *
 * @method addedToParent
 * @override
 * @see - sudo.js line 893
 */
marketstar.DataView.prototype.addedToParent = function() {
    var that = this.render();

    // if there is a postRender method define, call it
    if(this.postRender) {
        this.postRender();
    }

    return that; // expected return from super().
};
