_.namespace('marketstar');

/**
 * Constructor
 *
 * @class Mission
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.Mission = function(el, data) {
    $.extend(marketstar.Mission.prototype, Constants);
    $.extend(marketstar.Mission.prototype, AjaxMixins);
    $.extend(marketstar.Mission.prototype, UtilMixins);
    $.extend(marketstar.Mission.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.Mission.prototype = Object.create(marketstar.DataView.prototype);

/**
 * Post render() callback.  Contract requirement from DataView.
 * Put anything here that is dependent on the existence of elements in the DOM
 *
 * @method postRender
 */
marketstar.Mission.prototype.postRender = function() {
    var completed = this.model.getPath('Training.UserTrainingCompleted')
    bonus = this.model.getPath('Training.GamificationBonusName');


    if (!bonus) {
        this.$('.bonus-name').hide();
    }

    if (completed) {
        this.$('.check-mark').show();
        if (completed.Bonus) {
            this.$('.round-mark').show();
        }
    }
    else {
        this.$('.check-mark, .round-mark').hide();
    }


	this.$('.avg-rating').addClass(
		this.convertScoreToClassName(
			this.normalizeScore(
				this.model.get('Average')
			)
		)
	);

    if(window.device) {
        this.$el.on('touchend', $.proxy(this.toggleMissionDetailDisplay, this));
    }
    else {
        this.$el.on('click', $.proxy(this.toggleMissionDetailDisplay, this));
    }
};

marketstar.Mission.prototype.toggleMissionDetailDisplay = function(e) {
    if (this.parent && this.parent.iScroll && this.parent.iScroll.moved) return;

    var $el = this.$el
        ,$missionDetail = $el.find('.mission-detail')
        ,missionHeight = ($missionDetail.outerHeight() + 12);

    if($missionDetail.is(':visible')) {
        $missionDetail.slideUp(400);
        $el.removeClass('active');
        $el.animate({
            marginBottom: '0.5em'
        }, 400);
    }
    else {
        var $missions = $('.mission-list');
        $missions.find('.mission').removeClass('active').css('margin-bottom','12px');
        $missions.find('.mission-detail:visible').hide();

        $missionDetail.slideDown(400);
        $el.animate({
            marginBottom: missionHeight
        }, 400, function() {
            $el.addClass('active');
        });
    }
}