_.namespace('marketstar');

/**
 * Constructor
 * 
 * @class Product
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.Product = function(el, data) {
    $.extend(marketstar.Product.prototype, Constants);
    $.extend(marketstar.Product.prototype, AjaxMixins);
    $.extend(marketstar.Product.prototype, UtilMixins);
    $.extend(marketstar.Product.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.Product.prototype = Object.create(marketstar.DataView.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.Product.prototype.init = function() {
    this.$('a').on('click', this.anchorClickHandler);
};

/**
 * Render the page
 *
 * @method templatesReady
 */
marketstar.Product.prototype.templatesReady = function() {

};

/**
 * Post render() callback.  Contract requirement from DataView.
 * Put anything here that is dependent on the existence of elements in the DOM
 * 
 * @method postRender
 */
marketstar.Product.prototype.postRender = function() {

    this.$('.avg-rating').addClass(
        this.convertScoreToClassName(
            this.normalizeScore(
                this.model.getPath('Rating.Average')
            )
        )
    );

};