_.namespace('marketstar');

/**
 * Constructor
 *
 * @class ProductSpecificationGroupView
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.ProductSpecificationGroupView = function(el, data) {
    $.extend(marketstar.ProductSpecificationGroupView.prototype, Constants);
    $.extend(marketstar.ProductSpecificationGroupView.prototype, AjaxMixins);
    $.extend(marketstar.ProductSpecificationGroupView.prototype, UtilMixins);
    $.extend(marketstar.ProductSpecificationGroupView.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.ProductSpecificationGroupView.prototype = Object.create(marketstar.DataView.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.ProductSpecificationGroupView.prototype.init = function() {
    /*
    this.localStorage = new marketstar.LocalStorageObserverProxy();

    this.model.set(
        'templatePaths'
        ,{
            productSpecificationView: '_productSpecificationView.html'
        }
    );

    this.loadIntoModelFromLocalStorage(
        this.userDataKey
        ,$.proxy(this.loadTemplates, this)
        ,$.proxy(this.redirectToIndex, this)
    );
    */
};

/**
 * Render the page
 *
 * @method templatesReady
 */
marketstar.ProductSpecificationGroupView.prototype.templatesReady = function() {
    /*
    console.log("marketstar.ProductSpecificationGroupView.prototype.templatesReady");
    this.renderSpecification();
    */
}

/**
 * Render the individual specifications.
 * @method renderSpecification
 */
marketstar.ProductSpecificationGroupView.prototype.renderSpecification = function() {
    var specifications = this.model.get("productSpecifications");
console.log(specifications);
    if( specifications && specifications.length > 0 ) {
        var i
            ,renderTarget = $('.specifications');

        renderTarget.html('');
        for(i = 0; i < specifications.length; i++) {
            var specification
                ,template
                ,data
                ,child;

            specification = specifications[i];

            template = _.template( this.model.getPath('templates.productSpecificationView'), specification );
            data = {
                renderTarget: renderTarget
            };
            child = new marketstar.ProductSpecificationView(
                template
                ,data
            );
            this.addChild(child);
        }
    }
}


/**
 * Post render() callback.  Contract requirement from DataView.
 * Put anything here that is dependent on the existence of elements in the DOM
 *
 * @method postRender
 */
marketstar.ProductSpecificationGroupView.prototype.postRender = function() {

};