_.namespace('marketstar');

/**
 * Constructor
 *
 * @class ProductTrainingView
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.ProductTrainingView = function(el, data) {
    $.extend(marketstar.ProductTrainingView.prototype, Constants);
    $.extend(marketstar.ProductTrainingView.prototype, AjaxMixins);
    $.extend(marketstar.ProductTrainingView.prototype, UtilMixins);
    $.extend(marketstar.ProductTrainingView.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.ProductTrainingView.prototype = Object.create(marketstar.DataView.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.ProductTrainingView.prototype.init = function() {

};

/**
 * Render the page
 *
 * @method templatesReady
 */
marketstar.ProductTrainingView.prototype.templatesReady = function() {

}

/**
 * Post render() callback.  Contract requirement from DataView.
 * Put anything here that is dependent on the existence of elements in the DOM
 *
 * @method postRender
 */
marketstar.ProductTrainingView.prototype.postRender = function() {
    var completed = this.model.getPath('UserTrainingCompleted.Completed')
        ,bonus = this.model.getPath('UserTrainingCompleted.Bonus');

    if (completed) {
        this.$('.check-mark').show();
		this.$('h5').css('width','50%');
        if (bonus) {
            this.$('.round-mark').show();
        }
    }
    else {
        this.$('.check-mark').hide();
        this.$('.round-mark').hide();
    }
};