/**
 * Mixins that define global constants.
 *
 * @module Constants
 */
Constants = {
    templatesReadyEventName:   'templatesReady'
    ,templateLoadedEventName:   'templateLoaded'

    ,baseTemplatePath:          'template'
     
    ,trainingIdQueryParamKey:   'trainingId'
    ,contentUrlQueryParamKey:   'contentUrl'
    
    ,userDataKey:               'userData'
    ,userInfoKey:               'userInfo'
    ,permissionsKey:            'permissions'
    ,securityGroupsKey:         'securityGroups'
    ,dailyQuestionKey:          'dailyQuestion'
    ,achievementsModelKey:      'achievements'
    ,avatarBytesKey:            'avatarBytes'
    ,templatePathsModelKey:     'templatePaths'
    ,templatesModelKey:         'templates'
    ,trainingTypesModelKey:     'trainingTypes'
    ,trainingModelKeyPrefix:    'training'
    ,productCategoriesModelKey: 'productCategories'
    ,productDetailModelKey:     'productDetail'
    ,productsModelKey:          'products'
    ,trainingsModelKey:         'trainings'
    ,createCategoriesModelKey:  'createCategories'
    ,queryParameterModelKey:    'queryParams'
    ,achievementDataModelKey:   'achievementData'
    ,moduleCountModelKey:       'moduleCount'
    ,trainingModulesModelKey:   'TrainingModules'

    ,marketstarIdModelKey:                 'Id'
    ,marketstarNameModelKey:               'Name'
    ,marketstarBadgeModelKey:              'LargeBadgeUrl'
    ,marketstarPointsModelKey:             'Points'
    ,marketstarDescModelKey:               'Description'
    ,marketstarAvgModelKey:                'Average'
    ,marketstarContentUrlModelKey:         'ContentUrl'
    ,marketstarTrainingIdModelKey:         'TrainingId'
    ,marketstarAchievementAverageModelKey: 'Average'
    ,marketstarMyRatingModelKey:           'MyRating'
    ,marketstarModuleCompletedModelKey:    'UserModuleCompleted'
    ,marketstarProductPhotoModelKey:       'ProductPhoto'

    ,fullStarUrl:   'http://connect-plus.s3.amazonaws.com/images/rating-full.png'
    ,halfStarUrl:   'http://connect-plus.s3.amazonaws.com/images/rating-half.png'
    ,emptyStarUrl:  'http://connect-plus.s3.amazonaws.com/images/rating-empty.png'

    ,trainingContentType:   'training'
    ,quizContentType:       'quiz'

    // Static Strings
    ,allText:           'All'
    ,allStreamsText:    'All Streams'
    ,allTrainingsText:  'All Trainings'
    ,handleOpenUrl: ''

    ,createDropDownList:    [{Id: 0, Name: 'Status Update'}, {Id:1, Name:'Discussion'}]
};

var BarCodeType = Object.freeze({IMEI: 'CODE_128'});