ContentMixins = {
    /**
     * register Like and Reply clicks on content detail child views
     *
     * @method registerContentDetailClicks
     *
     */
    registerContentDetailClicks: function() {
        this.$('a.like-comment').on('click', $.proxy(this.submitCommentLike, this));
        this.$('a.reply-comment').on('click', $.proxy(this.showReplyArea, this));
    }

    ,showReplyArea: function(){
        if(this.getChild('reply'))
            this.cancelReply();

        var template = _.template(this.parent.model.getPath('templates.contentReply'), {});
        var child = new marketstar.ContentReply(template, $.extend({renderTarget: this.$('.content-reply')}, null));

        this.addChild(child, 'reply');
    }
    /**
     * register clicks for Reply view
     *
     * @method registerReplyClicks
     */
    ,registerReplyClicks: function(){
        this.$('a.reply-cancel').on('click', $.proxy(this.cancelReply, this));
        this.$('a.reply-post').on('click', $.proxy(this.submitReply, this));
    }

    /**
     * cancel contentDetail reply
     *
     * @method cancelReply
     */
    ,cancelReply: function(){
        if(this.name == 'reply'){
            this.parent.$el.find('.content-reply').html('');
            this.parent.removeChild('reply');
        }
        else{
           this.$el.find('.content-reply').html('');
           this.removeChild('reply');
        }
    }
    /**
     * submit contentDetail reply
     *
     * @method submitReply
     */
    ,submitReply: function(){
        var url = this.parent.model.getPath('resources.comments.ref') ? this.parent.model.getPath('resources.comments.ref') : this.parent.model.getPath('resources.messages.ref');
        var replyType = this.parent.model.getPath('resources.comments') ? 'comment' : 'message';
        var reply = {
            "content":
            {
                "type": "text/html",
                "text": this.$('.replyText').val()
            },
            "type": replyType
        }
        var that = this.parent.parent; //need to get to the _userBar template where ui-error exists
        if($.trim(reply.content.text) == 0){
            that.showError('You need to say something in order to reply :)');
            return;
        }

        var type = 'GET';

        if($.inArray('DELETE', this.parent.model.getPath('resources.comments.allowed')) >= 0)
            type =  "DELETE";
        else if($.inArray('POST', this.parent.model.getPath('resources.comments.allowed')) >= 0)
            type = "POST";


        this.basicAuthAjaxCall({
            url:        url
            ,type:      type
            ,contentType: 'application/json'
            ,basicAuth: this.model.get(this.userDataKey).authHash
            ,payload:   JSON.stringify(reply)
            ,modelName: 'postReply'
            ,success:   $.proxy(this.updateDetailView, this)
            ,fail:      ''
        });

    }

    ,submitCommentLike: function(){
        var type = 'GET';

        if($.inArray('DELETE', this.model.getPath('resources.likes.allowed')) >= 0)
            type =  "DELETE";
        else if($.inArray('POST', this.model.getPath('resources.likes.allowed')) >= 0)
            type = "POST";



        this.basicAuthAjaxCall({
            url:        this.model.getPath('resources.likes.ref')
            ,type:      type
            ,basicAuth: this.model.get(this.userDataKey).authHash
            ,modelName: 'postLike'
            ,success:   $.proxy(this.updateDetailView, this)
            ,fail:      $.proxy(this.updateDetailView, this)
        });
    }

    ,updateDetailView: function(requestProps, xhr){
        this.send('loadContent');
    }

};