
SalesCaptureMixins = {
    showScanner:function (promotionId) {

        var that = this;

        console.log('scanning');

        //USED TO TEST LOCALLY
        //this.postPromotion(promotionId, '0417101f32483');// '052800482623');// '012571000035515');

        var scanner = cordova.plugins.barcodeScanner;
        scanner.scan(function (result) {
            if (!result.cancelled) {
                //if (result.format != BarCodeType.IMEI) {
                //    alert("Code scanned is not a valid IMEI number.");
                //    marketstar.Scan.prototype.showScanner();
                //}
                console.log('RESULT:' + result.text + promotionId);
                that.postPromotion(promotionId, result.text);
            }
            else {
                location.href = 'salesCaptureMain.html';
            }

            //alert("We got a barcode\n" +
            //"Result: " + result.text + "\n" +
            //"Format: " + result.format + "\n" +
            //"Cancelled: " + result.cancelled);

        }, function (error) {
            console.log("Scanning failed: ", error);
            alert("Scanning Error:" + error);
        });

    },

    postPromotion: function (promotionId, value) {
        var urlParams = {
            urlPrefix: this.marketstarApiUrlPrefix()
            , urlPath: 'promotionregistrations'
        };

        //alert("SENDING: " + urlParams.urlPrefix + urlParams.urlPath + " P: " + promotionId +" V: " + value);
        //console.log("SENDING: " + urlParams.urlPrefix + urlParams.urlPath + " P: " + promotionId +" V: " + value);
        this.marketstarApiAjaxCall({
            url: this.buildUrl(urlParams)
            , body: {PromotionId: promotionId, Value: value, SubmitLocation: "mobile"}
            , type: 'POST'
            , modelName: 'promotionRegistrations'
            , success: $.proxy(this.postPromotionSuccess, this)
            , fail: $.proxy(this.postPromotionFail, this, promotionId)
        });

    },

    postPromotionSuccess: function (requestProps, xhr) {
        var data = JSON.parse(xhr.responseText);
        var message = '<div>' + (data.RegistrationValueName != null ? data.RegistrationValueName : '') + ' <strong>' + data.Value + '</strong> Saved! ' + data.StatusName + (data.Points > 0 ? ' <strong>+' + data.Points + '</strong>' : '') + '</div>';
        this.successfulEntry(message);
    },

    postPromotionFail: function (pId, requestProps, xhr) {
        var that = this;
        if(window.device) {
            navigator.notification.alert(
                    xhr.response,  // message
                    function(){
                        if (Config.allowScan) {
                            that.showScanner(pId);
                        } else {
                            window.location.href = "salesCaptureMain.html";
                        }
                    },         // callback
                    'Invalid Code',            // title
                    'Okay'                  // buttonName
            );
        }
        else
        {
            window.alert(xhr.response);
            if (Config.allowScan) {
                this.showScanner(pId);
            } else {
                window.location.href = "salesCaptureMain.html";
            }
        }

    },

    successfulEntry: function (message) {
        message = message.length > 0 ? message : "Saved Successfully";
        this.showMessage(message);
        setTimeout(function () {
            window.location.href = 'salesCaptureMain.html'
        }, 3000);
    },

    failedEntry: function (callScanner) {
        this.showError('Entry Error');
        if (callScanner) {
            setTimeout(function () {
                window.location.href = 'salesCaptureMain.html?callScanner=true'
            }, 1000);
        }
        else {
            setTimeout(function () {
                window.location.href = 'salesCaptureMain.html'
            }, 1000);
        }
    }
};