_.namespace('marketstar');

/**
 * Constructor
 *
 * @class SalesCapturePromotion
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.SalesCapturePromotion = function(el, data) {
    $.extend(marketstar.SalesCapturePromotion.prototype, Constants);
    $.extend(marketstar.SalesCapturePromotion.prototype, UtilMixins);
    $.extend(marketstar.SalesCapturePromotion.prototype, AjaxMixins);
    $.extend(marketstar.SalesCapturePromotion.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.SalesCapturePromotion.prototype = Object.create(marketstar.DataView.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.SalesCapturePromotion.prototype.init = function() {
    this.localStorage = new marketstar.LocalStorageObserverProxy();
    this.loadIntoModelFromLocalStorage(this.userDataKey); // TODO: what if fail?

    this.$('.promotion-container').on('click', $.proxy(this.showDetail, this, parseInt(this.$el.children('.promotion-container').attr('id'))));
};


marketstar.SalesCapturePromotion.prototype.showDetail = function(promotionId) {
    window.location = "salesCapturePromotionDetail.html?promotionId="+promotionId;
};


/**
 * Post render() callback.  Contract requirement from DataView.
 * Put anything here that is dependent on the existence of elements in the DOM
 *
 * @method postRender
 */
marketstar.SalesCapturePromotion.prototype.postRender = function() {};



