_.namespace('marketstar');

/**
 * Constructor
 *
 * @class ProductDetailView
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.PromotionDetailView = function(el, data) {
    $.extend(marketstar.PromotionDetailView.prototype, Constants);
    $.extend(marketstar.PromotionDetailView.prototype, AjaxMixins);
    $.extend(marketstar.PromotionDetailView.prototype, UtilMixins);
    $.extend(marketstar.PromotionDetailView.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.PromotionDetailView.prototype = Object.create(marketstar.DataView.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.PromotionDetailView.prototype.init = function() {
    this.localStorage = new marketstar.LocalStorageObserverProxy();

    this.loadIntoModelFromLocalStorage(
            this.userDataKey
            ,$.proxy(this.loadTemplates, this)
            ,$.proxy(this.redirectToIndex, this)
    );


};


/**
 * Render the page
 *
 * @method templatesReady
 */
marketstar.PromotionDetailView.prototype.templatesReady = function() {

};


/**
 * Post render() callback.  Contract requirement from DataView.
 * Put anything here that is dependent on the existence of elements in the DOM
 *
 * @method postRender
 */
marketstar.PromotionDetailView.prototype.postRender = function() {
    if(Config.allowScan){
        $('.scanCode').show();
    }  else{
        $('.enterCode').show();
    }
    this.$('.scanCode').on('click', $.proxy(this.showScanner, this));
    this.$('.enterCode').on('click', $.proxy(this.showPrompt, this));
};

marketstar.PromotionDetailView.prototype.showPrompt = function(){
    this.parent.showPrompt(parseInt(this.$el.children('.enterCode').attr('id')));
};

marketstar.PromotionDetailView.prototype.showScanner = function(){
    this.parent.showScanner(parseInt(this.$el.children('.scanCode').attr('id')));
};
