_.namespace('marketstar');

/**
 * Constructor
 * 
 * @class Training
 * @constructor
 * @extends marketstar.DataView
 * @uses Constants
 * @uses AjaxMixins
 * @uses UtilsMixins
 * @uses PageMixins
 */
marketstar.Training = function(el, data) {
    $.extend(marketstar.Training.prototype, Constants);
    $.extend(marketstar.Training.prototype, AjaxMixins);
    $.extend(marketstar.Training.prototype, UtilMixins);
    $.extend(marketstar.Training.prototype, PageMixins);
    this.construct(el, data);
};

marketstar.Training.prototype = Object.create(marketstar.DataView.prototype);

/**
 * Sudo init()
 *
 * @method init
 */
marketstar.Training.prototype.init = function() {
    this.localStorage = new marketstar.LocalStorageObserverProxy();
    this.loadIntoModelFromLocalStorage(this.userDataKey); // TODO: what if fail?
    //this.navMenuControl();
    //this.navMenuLinkHandler();
    this.$('a').on('click', this.anchorClickHandler);
};

/**
 * Post render() callback.  Contract requirement from DataView.
 * Put anything here that is dependent on the existence of elements in the DOM
 * 
 * @method postRender
 */
marketstar.Training.prototype.postRender = function() {

    var completed = this.model.get('UserTrainingCompleted')
        bonus = this.model.get('GamificationBonusName');

    if (!bonus) {
        this.$('.bonus-name').hide();
    }

    if (completed) {
        this.$('.check-mark').show();
        if (completed.Bonus) {
            this.$('.round-mark').show();
        }
    }
    else {
        this.$('.check-mark, .round-mark').hide();
    }

    this.$('.avg-rating').addClass(
        this.convertScoreToClassName(
            this.normalizeScore(
                this.model.getPath('Rating.Average')
            )
        )
    );

};
