﻿/*! http://mths.be/placeholder v2.0.7 by @mathias */
; (function (window, document, $) {

    var isInputSupported = 'placeholder' in document.createElement('input'),
	    isTextareaSupported = 'placeholder' in document.createElement('textarea'),
	    prototype = $.fn,
	    valHooks = $.valHooks,
	    hooks,
	    placeholder;

    if (isInputSupported && isTextareaSupported) {

        placeholder = prototype.placeholder = function () {
            return this;
        };

        placeholder.input = placeholder.textarea = true;

    } else {

        placeholder = prototype.placeholder = function () {
            var $this = this;
            $this
				.filter((isInputSupported ? 'textarea' : ':input') + '[placeholder]')
				.not('.placeholder')
				.bind({
				    'focus.placeholder': clearPlaceholder,
				    'blur.placeholder': setPlaceholder
				})
				.data('placeholder-enabled', true)
				.trigger('blur.placeholder');
            return $this;
        };

        placeholder.input = isInputSupported;
        placeholder.textarea = isTextareaSupported;

        hooks = {
            'get': function (element) {
                var $element = jQuery(element);
                return $element.data('placeholder-enabled') && $element.hasClass('placeholder') ? '' : element.value;
            },
            'set': function (element, value) {
                var $element = jQuery(element);
                if (!$element.data('placeholder-enabled')) {
                    return element.value = value;
                }
                if (value == '') {
                    element.value = value;
                    // Issue #56: Setting the placeholder causes problems if the element continues to have focus.
                    if (element != document.activeElement) {
                        // We can't use `triggerHandler` here because of dummy text/password inputs :(
                        setPlaceholder.call(element);
                    }
                } else if ($element.hasClass('placeholder')) {
                    clearPlaceholder.call(element, true, value) || (element.value = value);
                } else {
                    element.value = value;
                }
                // `set` can not return `undefined`; see http://jsapi.info/jquery/1.7.1/val#L2363
                return $element;
            }
        };

        isInputSupported || (valHooks.input = hooks);
        isTextareaSupported || (valHooks.textarea = hooks);

        jQuery(function () {
            // Look for forms
            jQuery(document).delegate('form', 'submit.placeholder', function () {
                // Clear the placeholder values so they don't get submitted
                var $inputs = jQuery('.placeholder', this).each(clearPlaceholder);
                setTimeout(function () {
                    $inputs.each(setPlaceholder);
                }, 10);
            });
        });

        // Clear placeholder values upon page reload
        jQuery(window).bind('beforeunload.placeholder', function () {
            jQuery('.placeholder').each(function () {
                this.value = '';
            });
        });

    }

    function args(elem) {
        // Return an object of element attributes
        var newAttrs = {},
		    rinlinejQuery = /^jQuery\d+$/;
        jQuery.each(elem.attributes, function (i, attr) {
            if (attr.specified && !rinlinejQuery.test(attr.name)) {
                newAttrs[attr.name] = attr.value;
            }
        });
        return newAttrs;
    }

    function clearPlaceholder(event, value) {
        var input = this,
		    $input = jQuery(input);
        if (input.value == $input.attr('placeholder') && $input.hasClass('placeholder')) {
            if ($input.data('placeholder-password')) {
                $input = $input.hide().next().show().attr('id', $input.removeAttr('id').data('placeholder-id'));
                // If `clearPlaceholder` was called from `$.valHooks.input.set`
                if (event === true) {
                    return $input[0].value = value;
                }
                $input.focus();
            } else {
                input.value = '';
                $input.removeClass('placeholder');
                input == document.activeElement && input.select();
            }
        }
    }

    function setPlaceholder() {
        var $replacement,
		    input = this,
		    $input = jQuery(input),
		    $origInput = $input,
		    id = this.id;
        if (input.value == '') {
            if (input.type == 'password') {
                if (!$input.data('placeholder-textinput')) {
                    try {
                        $replacement = $input.clone().attr({ 'type': 'text' });
                    } catch (e) {
                        $replacement = jQuery('<input>').attr(jQuery.extend(args(this), { 'type': 'text' }));
                    }
                    $replacement
						.removeAttr('name')
						.data({
						    'placeholder-password': true,
						    'placeholder-id': id
						})
						.bind('focus.placeholder', clearPlaceholder);
                    $input
						.data({
						    'placeholder-textinput': $replacement,
						    'placeholder-id': id
						})
						.before($replacement);
                }
                $input = $input.removeAttr('id').hide().prev().attr('id', id).show();
                // Note: `$input[0] != input` now!
            }
            $input.addClass('placeholder');
            $input[0].value = $input.attr('placeholder');
        } else {
            $input.removeClass('placeholder');
        }
    }

} (this, document, jQuery));

var qs = (window.SiteId != undefined && window.SiteId != 0 && window.SiteId != "") ? "siteid=" + window.SiteId : "siteid=1";
qs += (window.DeptId != undefined && window.DeptId != 0 && window.DeptId != "") ? "&deptid=" + window.DeptId : "";
if (window.qsParam) {
    qs += "&" + window.qsParam;
}
var hubConfig;
var isChatLoaded = false;
var name;
var chatid;
var isVisitor;
var chat;
var fbHeadShot;
var chatStage = "prechat";
function getCookieValue(cookieName) {
    var exp = new RegExp(escape(cookieName) + "=([^;]+)");
    if (exp.test(document.cookie + ";")) {
        exp.exec(document.cookie + ";");
        return unescape(RegExp.$1);
    }
    else
        return '';
}
jQuery(function () {
    var typingTimer;
    var isTyping = false;
    var isChatting = false;
    chat = jQuery.connection.chatHub;
    var chatHighline = 0;
    var sessionId = getCookieValue('vInlineSession');
    if (sessionId != null && sessionId != '') {
        if (Window.qsConfig) {
            qsConfig += "&sid=" + sessionId;
        }
        else if (qs != null && qs != '') {
            qs += "&sid=" + sessionId;
        }
    }

    if (jQuery('#mobileContent').size() != 0) {
        setTimeout(function () {
            if (!window.heightOfList) {
                heightOfList = 0;
            }
            heightOfList = jQuery('#messageList li').length * 44;
            if (heightOfList > jQuery('#mobileContent').css('min-height')) {
                jQuery('#mobileContent').css('height', heightOfList * .8);
                jQuery('#chat').css('height', heightOfList * 1);
            }

            jQuery("#mobileContent").css("min-height", window.innerHeight * .87).css("height", "90%");
            jQuery("#chat").css("min-height", window.innerHeight * .87).css("height", "100%");
        }, 1000);

    }

    jQuery("textarea").bind("blur", function () {
        jQuery(".ui-header-fixed").css("top", "0 !important");
        jQuery(".ui-footer-fixed").css("bottom", "0 !important");
    });

    //Callbacks
    chat.client.receiveSessionId = function (sessionId) {
        document.cookie = "vInlineSession=" + sessionId + "; path=/";
    }
    chat.client.receiveChatLines = function (newChatLines) {
        var newMessages = '';
        var chatPicture = '';
        var newPicture = true;

        jQuery.each(newChatLines, function (i, line) {
            if (line.Highline > chatHighline)
                chatHighline = line.Highline;

            var messageList = jQuery('#messageList');
            if (line.IsVisitorLine != isVisitor) {
                messageList.append("<div class ='SpaceTaker'></div>");
                isVisitor = line.IsVisitorLine;
                newPicture = true;
            }
            else {
                newPicture = false;
            }

            if (!line.IsVisitorLine) {
                if (line.HeadshotUrl)
                    jQuery('#vFrameshot').attr('src', line.HeadshotUrl);
                else
                    jQuery('#vFrameshot').attr('src', 'Portals\0\velaro\business_man_blue.png')

            }

            var newMessage = '<li style="text-align: left; height: 100%;">';
            if (line.HeadshotUrl != null && line.HeadshotUrl.length > 0) {
                var spaceTaker = messageList.find('div.SpaceTaker').last();
                if (newPicture) {
                    chatPicture += '<img style="margin-right: 10px; margin-top:10px; float: left; height:40px; width:40px;" height="40" width="40" src="' + line.HeadshotUrl + '" alt="' + line.FromDisplay + '"/>';
                }
                newMessage += '<div';
                if (line.IsVisitorLine == true) {
                    newMessage += ' class="visitorName"';
                }
                else {
                    if (line.FromDisplay == 'Notice') {
                        newMessage += 'class="noticeName"';
                    }
                    else {
                        newMessage += ' class="agentName"';
                    }
                }
                newMessage += ' style="display: inline;"><strong>' + line.FromDisplay + ':</strong></div>';
            }
            else if (fbHeadShot != null && fbHeadShot.length > 0) {
                var spaceTaker = messageList.find('div.SpaceTaker').last();
                if (newPicture) {
                    chatPicture += '<img style="margin-left: 10px; margin-top:10px; float: right; height:40px; width:40px;" height="40" width="40" src="' + fbHeadShot + '"/>';
                }

                newMessage += '<div';
                if (line.IsVisitorLine == true) {
                    newMessage += ' class="visitorName"';
                }
                else {
                    if (line.FromDisplay == 'Notice') {
                        newMessage += 'class="noticeName"';
                    }
                    else {
                        newMessage += ' class="agentName"';
                    }
                }
                newMessage += ' style="display: inline;"><strong>' + line.FromDisplay + ':</strong></div>';
            }
            else {
                chatPicture = '';
                var spaceTaker = messageList.find('div.SpaceTaker').last();
                newMessage += '<div';
                if (line.IsVisitorLine == true) {
                    newMessage += ' class="visitorName"';
                }
                else {
                    if (line.FromDisplay == 'Notice') {
                        newMessage += 'class="noticeName"';
                    }
                    else {
                        newMessage += ' class="agentName"';
                    }
                }
                newMessage += ' style="display: inline;"><strong>' + line.FromDisplay + ':</strong></div>';
            }
            var locOfPush = line.Text.indexOf('%LF:ForcePage%')
            if (locOfPush != -1) {
                var secondSpace = line.Text.indexOf(' ', line.Text.indexOf(' ', locOfPush) + 1);
                var lengthOfUrl = secondSpace - 15;
                var url = line.Text.substr(locOfPush + 15, lengthOfUrl);
                if (url.indexOf('http://') == -1) {
                    url = 'http://' + url;
                }
                window.open(url, 'Velaro Push');
                var full = line.Text.substr(locOfPush, secondSpace);
                url = '<a href="' + url + '" target="_blank">' + url + '</a>';
                line.Text = line.Text.replace(full, url);
            }
            newMessage += ' <span class="inlineMessage"> ' + line.Text + '</span>';

            /* Uncomment to get and display a timestamp of each line */
            //newMessage += ' <span class="vTimeStamp">[' + get_TimeStamp() + ']</span>';

            newMessage += '</li>';

            if (newPicture) {
                if (chatPicture != null && chatPicture.length > 0)
                    spaceTaker.append(chatPicture);

                spaceTaker.append("<ul class ='UserMessages'></ul>");
            }
            var userMessages = messageList.find('ul').last();

            if (line.IsVisitorLine == true) {
                userMessages.addClass('Visitor');
            }
            else {
                userMessages.addClass('Agent');
            }
            userMessages.append(newMessage);
        });

        if (!isChatting && chatStage != "postchat") {
            if (jQuery('#mobileContent').size() == 0)
                setContent('vChat');
            else
                setContentMobile('chat');
        }
        if (jQuery('#mobileContent').size() == 0)
            jQuery('#vChat').scrollTop(jQuery('#vChat')[0].scrollHeight);

        if (window.qsParams) {
            jQuery.connection.hub.qs = qsParams + "&highline=" + chatHighline
        }

    };

    chat.client.isAgentTyping = function (isAgentTyping) {
        if (isAgentTyping)
            jQuery("#agentTyping").show();
        else
            jQuery("#agentTyping").hide();
    };

    chat.client.updateQueueMessage = function (queueMessage) {

        jQuery('#queuemessage').html(queueMessage);
    };

    chat.client.agentsAvailable = function (isAgentAvailable) {
        if (!isAgentAvailable) {
            if (jQuery('#mobileContent').size() == 0) {
                setContent('availability');
                var defaultQuestions = '<div id="defaultUnavailable" style="padding: 10px;">';
                defaultQuestions += '<input type="email" class="input-block-level bootInput" name="email" id="email" required="true" placeholder="Email Address [Required]" data-istype="IsEmail" />';
                defaultQuestions += '<textarea class="input-block-level bootInput" style="height:auto;" cols="3" name="What is your question:" id="kbquestion" required="true" placeholder="What is your question: [Required]" ></textarea>';
                defaultQuestions += '<a href="#" class="btn btn-block btn-large" id="start" onclick="sendSurveyResults(\'unavailable\', \'' + 'defaultUnavailable' + '\');">Send</a>'
                defaultQuestions += '</div>'
                jQuery('#availability').append(defaultQuestions);

            }
            else
                setContentMobile('availability');
        }
        else {
            if (jQuery('#mobileContent').size() == 0)
                setContent('survey');
            else
                setContentMobile('survey');
        }
        jQuery('input, textarea').placeholder();
    };

    chat.client.chatEnded = function (incChatId) {
        chatid = incChatId
    };

    chat.client.error = function (message) {
        alert(message);
    };


    chat.client.receiveSurvey = function (survey) {
        buildSurvey(survey);
        jQuery('input, textarea').placeholder();
    };

    chat.client.receiveFacebook = function (facebook) {
        if (facebook != null && facebook.fBLogin) {
            jQuery('#facebook').append('<p>For an easy chat experience, use the facebook login to get to an agent quickly!</p>');
            jQuery('#facebook').append('<img src="' + facebook.FBLoginImg + '" alt="facebook" onclick="fbLogin(' + facebook.surveyId + ');" id="fbclick">');
            jQuery('#facebook').append('<hr />');
            jQuery('#facebook').show();
        }
    }

    function buildSurvey(survey) {
        jQuery('#builtSurvey').html('');
        jQuery('#facebook').html('');
        //check if prechat
        if (survey.SurveyType == 'prechatsurvey') {
            //load selection of FB vs Survey
            jQuery('#FBDecision').show();

        }
        else {
            chatid = survey.ChatId;
        }
        if (survey.SurveyType == 'prechatsurvey' && survey.SurveyID == 0) {
            jQuery('#builtSurvey').html("<a href='javascript:requestChat();'  class='btn btn-block btn-large' style='' id='vRequestChat'>" + survey.ButtonText + "</a>");
        }
        else {
            generateSurveyUI('builtSurvey', survey);
        }
        if (survey.SurveyType == 'notheresurvey') {
            if (jQuery('#mobileContent').size() == 0)
                setContent('survey');
            else
                setContentMobile('survey');
        }
    }

    jQuery('#send').click(function () {
        chat.server.sendMessage(jQuery('#message').val());
        jQuery('#message').val('');
        jQuery('#message').focus();
    });

    jQuery('#end').click(function () {
        chatStage = "postchat";
        chat.server.endChat().done(function (postChatSurvey) {
            if (postChatSurvey.SurveyID > 0) {
                buildSurvey(postChatSurvey);
                if (jQuery('#mobileContent').size() == 0)
                    setContent('survey');
                else
                    setContentMobile('survey');
                jQuery('#vChattingFooter').hide();
                jQuery('#vChattingToolbar').hide();
                jQuery('#facebook').hide();
            }
            else {
                resetChat(true);
            }
        });
    });

    jQuery("#message").keydown(function (e) {
        if (typingTimer && isTyping) {//Already set as typing
            window.clearTimeout(typingTimer);
        }
        else {//Just now set as typing
            chat.server.setTyping();
            isTyping = true;
        }
        typingTimer = window.setTimeout(function () { isTyping = false; }, 2000);
        if (e.which == "13") {
            jQuery('#send').click();
            return false;
        }
    });


    //Consider handling custprops in querystring instead of passing a dictionary to startchat
    if (window.qsConfig)
        jQuery.connection.hub.qs = qsConfig;
    else
        jQuery.connection.hub.qs = qs;

    if (typeof apppath != 'undefined') {
        if (apppath == true)
            hubConfig = configHub + '/signalr';
        else
            hubConfig = "";
    }
    else {
        hubConfig = "http://dev-ws1.velaro.net/chatserver/signalr";
    }
    jQuery.connection.hub.url = hubConfig;
    if (jQuery('#mobileContent').size() != 0) {
        jQuery.connection.hub.start().done(function () {

        });
    }
});

function requestChat() {
    chat.server.requestChat(null, null, null);
    if (jQuery('#mobileContent').size() == 0)
        setContent('queue');
    else
        setContentMobile('queue');
}

function resetChat(callEndChat) {
    if (callEndChat) {
        chat.server.endChat();
    }
    jQuery.connection.hub.stop();
    if (jQuery('#mobileContent').size() == 0) {
        jQuery('#vInlineChat').css('display', 'none');
        jQuery('#vChatTab').css('display', 'block');
        document.cookie = "vInlineState=closed; path=/";
        setContent('survey');
    }
    else {
        setContentMobile('survey');
    }
    jQuery('#messageList').empty();

    chatStage = 'prechat'
    isChatLoaded = false;
    isVisitor = null;
}

function receiveDefaultSurveyResults(surveyResults) {
    var answers = surveyResults.Answers;
    var name = 'guest';
    var email = '';
    var customprops = '';
    for (var i = 0; i < answers.length; i++) {
        if (answers[i].IsUsername == true) {
            name = answers[i].Text;
        }
        else if (answers[i].IsEmail == true) {
            email = answers[i].Text;
        }
        else {
            customprops['question'] = answers[i].Text;
        }


    }

    chat.server.requestChat(name, email, customprops);

    if (jQuery('#mobileContent') == null)
        setContent('queue');
    else
        setContentMobile('queue');

    jQuery("#survey").hide();
}

function receiveSurveyResults(surveyResults) {
    chat.server.submitSurvey(surveyResults).done(function (kb) {
        if (kb != null && kb != 'ToChat') {
            jQuery('#kb').html('');
            jQuery('#kb').html(kb);
            if (jQuery('#mobileContent').size() == 0)
                setContent('kb');
            else
                setContentMobile('kb');

            jQuery('#startkb').click(function () {
                chat.server.requestChat(null, null, null);
                jQuery('#kb').hide();
                if (jQuery('#mobileContent') == null)
                    setContent('queue');
                else
                    setContentMobile('queue');
            });
        }
        else {
            if (surveyResults.SurveyType == "prechat") {
                if (jQuery('#mobileContent') == null)
                    setContent('queue');
                else
                    setContentMobile('queue');
            }
        }
    });
    jQuery("#survey").hide();
}

function setContentMobile(active) {
    jQuery('#mobileContent').children().hide();
    jQuery('#' + active).show();

    if (active == 'chat') {
        if (window.myScroll) {
            myScroll.refresh();
        }
        isChatting = true;
        jQuery('#end').show();
        jQuery('#footer').show();
        jQuery('#survey').hide();
        jQuery('#queue').hide();
    }
    else if (active == 'survey') {
        jQuery('#navbar-static-bottom').hide();
        jQuery('#end').hide();
        jQuery('#footer').hide();
        jQuery('#facebook').hide();
    }
    else if (active == 'queue') {
        jQuery('#survey').hide();
        if (name != null && name.length > 0) {
            jQuery('#queue').html('');
            jQuery('#queue').html('Welcome, ' + name + '! An agent will be with you shortly.');
        }
    }
    else {
        isChatting = false;
        jQuery('#end').hide();
        jQuery('#footer').hide();
    }
    if (active == 'thanks') {
        window.scrollto(0, 0);
    }
}

function setContent(active) {
    jQuery('#vCenter').children().hide();
    jQuery('#' + active).show();

    if (active == 'vLoading') {
        jQuery('#vInlineHeader').show();
    }
    if (active == 'vChat') {
        chatStage = "chat"
        isChatting = true;
        jQuery('#end').show();
        jQuery('#vChattingFooter').show();
        jQuery('#vChattingToolbar').show();
        jQuery('#survey').hide();
        jQuery('#queue').hide();
        jQuery('#vChatTab').hide();
        jQuery('#vInlineChat').show();
    }
    else if (active == 'survey') {
        jQuery('#navbar-static-bottom').hide();
        jQuery('#end').hide();
        jQuery('#vChattingFooter').hide();
        jQuery('#vChattingFooter').hide();
        jQuery('#vChattingToolbar').hide();
        jQuery('#survey').show();
    }
    else if (active == 'queue') {
        chatStage = "queue";
        jQuery('#survey').hide();
        if (name != null && name.length > 0) {
            jQuery('#queue').html('');
            jQuery('#queue').html('Welcome, ' + name + '! An agent will be with you shortly.');
        }
    }
    else {
        isChatting = false;
        jQuery('#end').hide();
        jQuery('#vChattingToolbar').hide();
    }
    if (active == 'thanks') {
        window.scrollto(0, 0);
    }
}

//
// FB Login
//
//
function fbLogin(surveyId) {
    FB.Event.subscribe('auth.authResponseChange', function (response) {
        fbLogin(surveyId);
    });

    FB.getLoginStatus(function (response) {
        if (response.status === 'connected') {
            // the user is logged in and has authenticated your
            // app, and response.authResponse supplies
            // the user's ID, a valid access token, a signed
            // request, and the time the access token 
            // and signed request each expire
            var uid = response.authResponse.userID;
            var accessToken = response.authResponse.accessToken;

            FB.api('/me', function (resp) {
                if (surveyId == 0) {
                    fbRedirect(resp);
                }
                else {
                    loadFBInfo(resp);
                }

            });

        } else {
            FB.login(function (response) {
                if (response.authResponse) {
                    FB.api('/me', function (resp) {
                        if (surveyId == 0) {
                            fbRedirect(resp);
                        } else {
                            loadFBInfo(resp);
                        }
                    });
                } else {

                }
            }, { scope: 'email' });
        }
    });
}

function loadFBInfo(fb) {
    name = 'Guest';
    if (fb.first_name) {
        name = fb.first_name;
        if (fb.last_name) {
            name += ' ' + fb.last_name;
        }
    }

    jQuery('.fblogin').css('display', 'none');
    jQuery('.snSkip').css('display', 'none');
    jQuery('.survey').css('display', 'block');
    fbHeadShot = 'https://graph.facebook.com/' + fb.id + '/picture'

    var customProps = new Array();

    customProps = fb;
    createFBSurveyEntry(name, fb.email, fb);


    if (name != null && name.length > 0) {
        jQuery('#queue').html('');
        jQuery('#queue').html('Welcome, ' + name + '! An agent will be with you shortly.');
    }

    jQuery("#survey").hide();
    jQuery("#queue").show();
}

function fbRedirect(fb) {
    var name = 'Guest';
    var email;

    if (fb.first_name) {
        name = fb.first_name;

        if (fb.last_name) {
            name += ' ' + fb.last_name;
        }
    }

    if (fb.email) {
        email = fb.email;
    }

    var redirectUrl = window.location.href.replace(/(?!stage=)(\w+)(?=&)/, "chat");

    redirectUrl += '&visitor_name=' + name;

    if (email) {
        redirectUrl += '&email=' + email;
    }

    window.location = redirectUrl;

}
function createFBSurveyEntry(name, email, fb) {
    var results = jQuery('#surveyQuestions');
    var answers = new Array();
    var customProps = {};

    var surveyResults = new Object();

    surveyResults.SurveyId = 0;
    surveyResults.ChatId = '';
    surveyResults.SocialLoginId = fb.id;
    surveyResults.SurveyType = 'prechat';


    for (var i = 0; i < jQuery(results).children().length; i++) {
        var answer = new Object();

        answer.QuestionId = 0;
        answer.SubQuestionId = 0;
        answer.Text = "";
        answer.IsUsername = false;
        answer.IsEmail = false;
        answer.IsPhone = false;
        answer.IsDeptName = false;
        answer.RequiresAlert = false;



        answer.QuestionId = jQuery(jQuery(results).children()[i]).attr('data-questionid');
        answer.Text = jQuery(jQuery(results).children()[i]).attr('value');
        var type = jQuery(jQuery(results).children()[i]).attr('data-istype');

        if (type == "IsEmail") {
            answer.IsEmail = true;
            if (email != null)
                answer.Text = email;
        }
        else if (type == "IsPhone") {
            answer.IsPhone = true;
        }
        else if (type == "IsUserName") {
            answer.IsUsername = true;
            if (name != null)
                answer.Text = name;
        }
        else if (type == "IsKBQuestion") {
            answer.IsKBQuestion = true;
        }

        answers.push(answer);
    }

    surveyResults.SurveyId = document.getElementById("surveyID").value;
    surveyResults.Answers = answers;
    chat.server.submitSurvey(surveyResults);
}

jQuery(document).ready(function () {
    jQuery('#vChatTab').click(function () {
        var browserName = get_browser();
        var browserVersion = get_browser_version();

        if ((browserName == "Internet Explorer" && parseInt(browserVersion) < 8) || (browserName == 'Chrome' && parseInt(browserVersion) < 16) || (browserName == 'Firefox' && parseInt(browserVersion) < 16)) {
            this.newWindow = window.open(popout, 'velaro chat', 'toolbar=no,location=no,directories=no,menubar=no,status=no,scrollbars=no,resizable=yes,replace=no');
        }
        else {
            jQuery('#vInlineChat').css('display', 'block');
            jQuery('#vChatTab').css('display', 'none');
            if (!isChatLoaded) {
                setContent('vLoading');
                jQuery.connection.hub.start().done(function () {
                    isChatLoaded = true;
                    document.cookie = "vInlineState=expanded; path=/";
                });
            }
        }

    });

    jQuery('#vMinimize').click(function () {
        jQuery('#vInlineChat').css('display', 'none');
        jQuery('#vChatTab').css('display', 'block');
        document.cookie = "vInlineState=minimized; path=/";
    });

    jQuery('#vClose').click(function () {
        var reallyClose = true;
        if (chatStage == 'chat' || chatStage == 'queue') {
            reallyClose = confirm('This will end your chat session');
        }
        if (reallyClose) {
            resetChat(true);
        }
    });
    var state = getCookieValue('vInlineState');
    if (state != null && state != '') {
        if (state == 'expanded' || state == 'minimized') {
            jQuery('#vChatTab').click();
        }
        if (state == 'minimized') {
            jQuery('#vMinimize').click();
        }
    }
});

(function (d, s, id) {
    var js, fjs = d.getElementsByTagName(s)[0];
    if (d.getElementById(id)) return;
    js = d.createElement(s); js.id = id;
    js.src = 'http://connect.facebook.net/en_US/all.js';
    fjs.parentNode.insertBefore(js, fjs);
} (document, 'script', 'facebook-jssdk'));

// Init the SDK upon load
window.fbAsyncInit = function () {
    FB.init({
        appId: '385056004873966', // App ID
        status: true, // check login status
        cookie: true, // enable cookies to allow the server to access the session
        xfbml: true  // parse XFBML
    });
}

// Utility function to convert "a=b&c=d" into { a:'b', c:'d' }
function parseQueryString(queryString) {
    var params = {};
    if (queryString) {
        var keyValues = queryString.split('&');
        for (var i = 0; i < keyValues.length; i++) {
            var pair = keyValues[i].split('=');
            params[pair[0]] = pair[1];
        }
    }
    return params;
}

function emailTranscript() {
    var win = window.open('');
    chat.server.getTranscriptUrl().done(function (url) {
        if (url != null) {
            win.location = url;
            win.focus();
        }
    });
}

function get_browser() {
    var N = navigator.appName, ua = navigator.userAgent, tem;
    var M = ua.match(/(opera|chrome|safari|firefox|msie)\/?\s*(\.?\d+(\.\d+)*)/i);
    if (M && (tem = ua.match(/version\/([\.\d]+)/i)) != null) M[2] = tem[1];
    M = M ? [M[1], M[2]] : [N, navigator.appVersion, '-?'];
    return M[0];
}
function get_browser_version() {
    var N = navigator.appName, ua = navigator.userAgent, tem;
    var M = ua.match(/(opera|chrome|safari|firefox|msie)\/?\s*(\.?\d+(\.\d+)*)/i);
    if (M && (tem = ua.match(/version\/([\.\d]+)/i)) != null) M[2] = tem[1];
    M = M ? [M[1], M[2]] : [N, navigator.appVersion, '-?'];
    return M[1];
}
function get_TimeStamp() {
    var tdate = new Date();
    return tdate.getHours() + ":" + tdate.getMinutes() + ":" + tdate.getSeconds();
}
